;________________________________________________________________________
;
;                                A X 2 5 . A S M
;________________________________________________________________________
;
; AX25 UI Sending Routines - by Max IK3SVW - July 2001
; Based on original u2k package by Byon Garrabrant, N6BG
;________________________________________________________________________
;
	cblock				; variables
		ax25_temp
		ax25_sending_char
		ax25_sending_count
		ax25_bit_history
		ax25_crc_hi
		ax25_crc_lo
	endc
;________________________________________________________________________

AX25_Send_Zero
	movlw	'0'
	goto	AX25_Send_Data

AX25_Send_Hex
	movwf	temp
	swapf	temp, W
	call	AX25_Send_Hex_Nibble
	movfw	temp
AX25_Send_Hex_Nibble
	andlw	H'0F'
	addlw	'0'
	goto	AX25_Send_Data

AX25_Send_Bit
	rlf	ax25_bit_history, F	; store the last 8 bits sent
	rrf	ax25_bit_history, W	; restore the bit

	call	Tone_Toggle_If_No_Carry

	comf	ax25_bit_history, W	; check the last 5 bits
	andlw	H'1F'
 	skpz				; if not all 1s
 	 return				; return

	clrc				; send a transparent 0 bit
	goto	AX25_Send_Bit
;________________________________________________________________________

AX25_Send_Flag:
	movlw	H'7E'
	movwf	ax25_sending_char
	movlw	8
	movwf	ax25_sending_count
AX25_Send_Flag_Loop
	rrf	ax25_sending_char, F	; get bit for sending
 	call	AX25_Send_Bit
	clrf	ax25_bit_history	; no bit stuffing for flags
	decfsz	ax25_sending_count, F
	 goto	AX25_Send_Flag_Loop
	return 
;________________________________________________________________________

AX25_Send_Start
	movlw	OPT_AUTO_TX_DELAY	; send initial flags
	call	Get_Option
	movwf	ax25_temp
	call	Tone_Enable		; start tone

AX25_Send_Start_Flag_Loop
	call	AX25_Send_Flag
	decfsz	ax25_temp, F
	 goto	AX25_Send_Start_Flag_Loop

	movlw	H'FF'			; crc inits to 0xFFFF
	movwf	ax25_crc_hi
	movwf	ax25_crc_lo

sendHeader
	movlw	OPT_CALLSIGN_DIGI
	movwf	temp
Packet_Send_Callsign
	movfw	temp
	call	Get_Option
	iorlw	0
	skpnz
	 goto	Packet_Send_Type
	movwf	temp2
	incf	temp, W
	call	Get_Option
	iorlw	0
	clrc
	skpnz
	 setc
 	rlf	temp2, W
	call	AX25_Send_Data
	incf	temp, F
	goto	Packet_Send_Callsign
Packet_Send_Type
	movlw	H'03'
	call	AX25_Send_Data
	movlw	H'F0'
	goto	AX25_Send_Data
;________________________________________________________________________

AX25_Send_Dot
	movlw	'.'

AX25_Send_Data
	movwf	ax25_sending_char
	movlw	8
	movwf	ax25_sending_count
AX25_Send_Data_Loop
	rrf	ax25_sending_char, W	; get bit for CRC

	movlw	1
	skpnc
	 xorwf	ax25_crc_lo, F		; crc ^= d & 1;

	clrc
	rrf	ax25_crc_hi, F
	rrf	ax25_crc_lo, F
	skpc
	 goto	AX25_CRC_Done
	movlw	H'08'
	xorwf	ax25_crc_lo, F
	movlw	H'84'
	xorwf	ax25_crc_hi, F		; crc=(crc & 1) ? (crc >>1)^POLY : (crc >> 1);
AX25_CRC_Done

	rrf	ax25_sending_char, F	; get bit for sending
 	call	AX25_Send_Bit
	decfsz	ax25_sending_count, F
	 goto	AX25_Send_Data_Loop
	return 
;________________________________________________________________________

AX25_Send_End
	movlw	H'FF'			; send CRC
	xorwf	ax25_crc_lo, F		; invert lo
	xorwf	ax25_crc_hi, W		; invert hi and
	movwf	ax25_temp		; save in temp
	movfw	ax25_crc_lo		; send lo
	call	AX25_Send_Data
	movfw	ax25_temp		; send hi
	call	AX25_Send_Data

	call	AX25_Send_Flag		; send final flags
	call	AX25_Send_Flag		; send final flags

	call	Tone_Disable		; stop tone
	return
;________________________________________________________________________